#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2100one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 2100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2100one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one21004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                                       
# -------------------------------------------------------------------------------------------------
# 2100 
# -------------------------------------------------------------------------------------------------                                          
shot2one21004xi = {
                  1:'0x0y2099z',
                  2:'0x1390y1573z',
                  3:'0x63y2099z',
                  4:'100x107y2094z',
                  5:'1012x944y1578z',
                  6:'1023x1221y1367z',
                  7:'1036x1431y1134z',
                  8:'1048x880y1592z',
                  9:'1063x1528y971z',
                  10:'1077x1156y1383z',
                  11:'1080x814y1605z',
                  12:'108x128y2093z',
                  13:'1102x1366y1152z',
                  14:'1108x747y1619z',
                  15:'1126x1088y1398z',
                  16:'1135x1463y989z',
                  17:'113x150y2091z',
                  18:'1165x1298y1169z',
                  19:'1170x1018y1414z',
                  20:'117x173y2089z',
                  21:'118x197y2087z',
                  22:'118x221y2084z',
                  23:'1204x1394y1008z',
                  24:'120x1742y1166z',
                  25:'120x258y2181z',
                  26:'1211x947y1429z',
                  27:'1223x1226y1186z',
                  28:'1247x874y1445z',
                  29:'1268x1321y1026z',
                  30:'1276x1153y1204z',
                  31:'12x17y2099z',
                  32:'1325x1077y1221z',
                  33:'1328x1246y1044z',
                  34:'1370x999y1238z',
                  35:'1383x1168y1063z',
                  36:'138x1585y1369z',
                  37:'142x1351y1601z',
                  38:'1434x1088y1081z',
                  39:'163x1942y780z',
                  40:'192x1861y952z',
                  41:'20x229y2087z',
                  42:'210x1326y1614z',
                  43:'210x1721y1183z',
                  44:'219x1562y1385z',
                  45:'22x35y2099z',
                  46:'264x1923y799z',
                  47:'275x1297y1628z',
                  48:'288x1839y970z',
                  49:'298x1535y1401z',
                  50:'298x1696y1201z',
                  51:'29x1757y1149z',
                  52:'29x207y2089z',
                  53:'2x21y2099z',
                  54:'2x42y2099z',
                  55:'30x55y2099z',
                  56:'339x1265y1641z',
                  57:'362x1899y819z',
                  58:'36x185y2091z',
                  59:'374x1503y1416z',
                  60:'37x75y2098z',
                  61:'382x1812y989z',
                  62:'383x1666y1218z',
                  63:'399x1230y1654z',
                  64:'41x162y2093z',
                  65:'41x96y2097z',
                  66:'43x118y2096z',
                  67:'43x140y2094z',
                  68:'448x1468y1432z',
                  69:'457x1192y1667z',
                  70:'459x1869y838z',
                  71:'467x1632y1235z',
                  72:'473x1780y1008z',
                  73:'512x1151y1679z',
                  74:'520x1429y1447z',
                  75:'547x1594y1252z',
                  76:'554x1834y857z',
                  77:'563x1743y1026z',
                  78:'564x1107y1692z',
                  79:'56x1604y1353z',
                  80:'588x1386y1462z',
                  81:'613x1062y1704z',
                  82:'61x1956y760z',
                  83:'625x1551y1269z',
                  84:'646x1795y876z',
                  85:'650x1701y1044z',
                  86:'654x1340y1477z',
                  87:'658x1014y1716z',
                  88:'66x51y2098z',
                  89:'700x1505y1285z',
                  90:'700x964y1728z',
                  91:'716x1291y1492z',
                  92:'71x1372y1587z',
                  93:'734x1655y1062z',
                  94:'736x1750y895z',
                  95:'739x912y1740z',
                  96:'772x1454y1302z',
                  97:'774x1239y1507z',
                  98:'774x859y1752z',
                  99:'79x68y2097z',
                  100:'805x805y1763z',
                  101:'814x1605y1080z',
                  102:'823x1701y914z',
                  103:'829x1185y1521z',
                  104:'833x750y1775z',
                  105:'840x1401y1318z',
                  106:'858x694y1786z',
                  107:'878x638y1797z',
                  108:'881x1128y1536z',
                  109:'892x1551y1098z',
                  110:'905x1344y1335z',
                  111:'906x1648y933z',
                  112:'90x87y2096z',
                  113:'929x1068y1550z',
                  114:'95x1878y933z',
                  115:'966x1284y1351z',
                  116:'966x1493y1116z',
                  117:'973x1007y1564z',
                  118:'986x1590y952z',
                  119:'9x251y2084z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2100one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2100one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2100NE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2100NE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2100NE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2100NE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2100NE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE21004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one21004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2100NE4XI - SUCCEEDED TO PUT SHOT2ONE21004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE21004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2100NE4XI *** FAILED TO PUT SHOT2ONE21004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2100NE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one21004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one21004xi</nack2put4xi>" 
                 
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
    
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2100NE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one21004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE2100NE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2100NE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2100one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
